"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AxiosBatch = void 0;
var axios_1 = __importDefault(require("axios"));
var axios_retry_1 = __importDefault(require("axios-retry"));
var url_1 = require("url");
var utils_1 = require("./utils");
var retryCodes = [408, 500, 502, 504, 522, 524];
var AxiosBatch = /** @class */ (function () {
    /**
     *
     * @param {Batch.AxiosBatchConstructor} config
     */
    function AxiosBatch(config) {
        if (config === void 0) { config = {}; }
        var _this = this;
        this.getBatchResults = function (batch, headers, verbose) { return __awaiter(_this, void 0, void 0, function () {
            var results, errors, err_1;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        results = [];
                        errors = [];
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, 4, 5]);
                        return [4 /*yield*/, axios_1.default.all((batch).map(function (batchItem) {
                                var _a = batchItem.data, data = _a === void 0 ? undefined : _a, url = batchItem.url, method = batchItem.method, batchID = batchItem.id;
                                var hostname = (new url_1.URL(_this.baseURL || url)).hostname;
                                return _this.client({
                                    url: url,
                                    method: method,
                                    headers: headers,
                                    data: data,
                                    batchID: batchID
                                })
                                    .catch(function (err) {
                                    var _a, _b;
                                    verbose && console.log("[info]:: request for ".concat(batchID, " failed with ").concat(((_a = err === null || err === void 0 ? void 0 : err.response) === null || _a === void 0 ? void 0 : _a.status) || 500));
                                    _this.degradationChecks[hostname] = ++_this.degradationChecks[hostname] || 0;
                                    return errors.push({ id: batchID, error: ((_b = err === null || err === void 0 ? void 0 : err.response) === null || _b === void 0 ? void 0 : _b.status) || 500 });
                                });
                            }))
                                .then(axios_1.default.spread(function () {
                                var batchResults = [];
                                for (var _i = 0; _i < arguments.length; _i++) {
                                    batchResults[_i] = arguments[_i];
                                }
                                return batchResults.forEach(function (result) {
                                    var _a, _b, _c;
                                    if (typeof result === 'object') {
                                        var serverUrl = (_a = result.config) === null || _a === void 0 ? void 0 : _a.baseURL;
                                        if (serverUrl) {
                                            var hostname = (new url_1.URL(serverUrl)).hostname;
                                            _this.degradationChecks[hostname] = Math.max(--_this.degradationChecks[hostname] || 0, 0);
                                        }
                                        verbose && console.log("[info]:: request for ".concat((_b = result.config) === null || _b === void 0 ? void 0 : _b.batchID, " succeeded"));
                                        result.data && results.push({ data: result.data, id: (_c = result.config) === null || _c === void 0 ? void 0 : _c.batchID });
                                    }
                                });
                            }))
                                .catch(function (err) { throw err; })];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 5];
                    case 3:
                        err_1 = _a.sent();
                        throw err_1;
                    case 4: return [2 /*return*/, { results: results, errors: errors }];
                    case 5: return [2 /*return*/];
                }
            });
        }); };
        this.axiosBatch = function (_a) {
            var urls = _a.urls, _b = _a.parallelRequests, parallelRequests = _b === void 0 ? 5 : _b, _c = _a.batchDelayInMs, batchDelayInMs = _c === void 0 ? 250 : _c, headers = _a.headers, _d = _a.verbose, verbose = _d === void 0 ? false : _d;
            return __awaiter(_this, void 0, void 0, function () {
                var allSuccess, allErrors, start, urlBatch, batchesCount, idx, processingBatch, _e, results, errors;
                return __generator(this, function (_f) {
                    switch (_f.label) {
                        case 0:
                            allSuccess = [];
                            allErrors = [];
                            start = 0;
                            this.degradationChecks = {};
                            urlBatch = (0, utils_1.makeBatchUrl)(urls);
                            if (!(0, utils_1.hasValidBaseURL)(this.baseURL, urlBatch))
                                throw new Error('Provide either a baseURL or fully qualified urls');
                            batchesCount = Math.ceil(urlBatch.length / parallelRequests);
                            idx = 0;
                            _f.label = 1;
                        case 1:
                            if (!(idx < batchesCount)) return [3 /*break*/, 5];
                            if (this.isDegradationSafety && (0, utils_1.checkHostIntegrity)(this.degradationChecks, this.degradationMax)) {
                                return [2 /*return*/, { allSuccess: allSuccess, allErrors: __spreadArray(__spreadArray([], allErrors, true), [{ id: 'warning', message: 'too many errors from server' }], false) }];
                            }
                            processingBatch = urlBatch.slice(start, start + parallelRequests);
                            start += parallelRequests;
                            return [4 /*yield*/, this.getBatchResults(processingBatch, headers, verbose)];
                        case 2:
                            _e = _f.sent(), results = _e.results, errors = _e.errors;
                            allSuccess.push.apply(allSuccess, results);
                            allErrors.push.apply(allErrors, errors);
                            return [4 /*yield*/, (0, utils_1.waitFor)(batchDelayInMs)];
                        case 3:
                            _f.sent();
                            _f.label = 4;
                        case 4:
                            idx++;
                            return [3 /*break*/, 1];
                        case 5: return [2 /*return*/, { allSuccess: allSuccess, allErrors: allErrors }];
                    }
                });
            });
        };
        var _a = config.headers, headers = _a === void 0 ? {} : _a, client = config.client, baseURL = config.baseURL, _b = config.backoffInterval, backoffInterval = _b === void 0 ? 300 : _b, _c = config.degradationMax, degradationMax = _c === void 0 ? 6 : _c, _d = config.isDegradationSafety, isDegradationSafety = _d === void 0 ? false : _d;
        this.headers = headers;
        this.baseURL = client ? client.defaults.baseURL : baseURL;
        this.client = client || axios_1.default.create({ baseURL: baseURL, headers: headers });
        this.backoffInterval = backoffInterval;
        this.degradationChecks = {};
        this.degradationMax = degradationMax;
        this.isDegradationSafety = isDegradationSafety;
        (0, axios_retry_1.default)(this.client, {
            retries: 3,
            retryDelay: function (retryCount) {
                return retryCount * _this.backoffInterval; // interval for retries
            },
            retryCondition: function (error) {
                var _a;
                var status = ((_a = error === null || error === void 0 ? void 0 : error.response) === null || _a === void 0 ? void 0 : _a.status) || 500;
                return retryCodes.includes(status);
            }
        });
    }
    return AxiosBatch;
}());
exports.AxiosBatch = AxiosBatch;
